import React from 'react';
import ReactDOM from 'react-dom';
import {MorphTransition} from 'react-svg-morph';
import {Motion, spring} from 'react-motion';
import TiBatteryLow from 'react-icons/lib/ti/battery-low';
import TiBatteryFull from 'react-icons/lib/ti/battery-full';

class App extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            checked: false
        };
    }
    render() {
        return (
            <Motion defaultStyle={{x: 0}} style={{x: spring(100, [200, 17])}}>
                {value =>
                <MorphTransition width={100} height={100} progress={value.x}>{{
                    from: <TiBatteryLow key={1}/>,
                    to: <TiBatteryFull key={2}/>,
                }}</MorphTransition>}
            </Motion>
        );
    }
}

ReactDOM.render(<App />, document.getElementById('app'));
