// request animation frame
'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _ExtractSvgPaths = require('./ExtractSvgPaths');

var _ExtractSvgPaths2 = _interopRequireDefault(_ExtractSvgPaths);

var _morph = require('./morph');

require('./raf');

var renderSubtreeIntoContainer = _reactDom2['default'].unstable_renderSubtreeIntoContainer;

var SvgMorph = (function (_React$Component) {
    _inherits(SvgMorph, _React$Component);

    function SvgMorph(props) {
        _classCallCheck(this, SvgMorph);

        _get(Object.getPrototypeOf(SvgMorph.prototype), 'constructor', this).call(this, props);

        this.progress = 0;
        this.state = {
            current: []
        };
    }

    _createClass(SvgMorph, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.node = document.createElement('div');
            this.node.style.display = 'none';
            document.body.appendChild(this.node);
            var path = this.getSvgInfo(this.props);
            var paths = (0, _morph.normalizePaths)(path, path, { rotation: this.props.rotation });
            this.from = paths.from;
            this.to = paths.to;
            var current = (0, _morph.getProgress)(this.from, this.to, 1);
            this.setState({ current: current });
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            this.from = this.to;
            this.to = this.getSvgInfo(nextProps);
            var paths = (0, _morph.normalizePaths)(this.from, this.to, { rotation: this.props.rotation });
            this.from = paths.from;
            this.to = paths.to;
            this.progress = 0;
            cancelAnimationFrame(this.raf);
            this.startTime = undefined;
            this.animate();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (this.node) {
                _reactDom2['default'].unmountComponentAtNode(this.node);
                document.body.removeChild(this.node);
            }
        }
    }, {
        key: 'getSvgInfo',
        value: function getSvgInfo(props) {
            renderSubtreeIntoContainer(this, _react2['default'].cloneElement(props.children), this.node);
            var svg = this.node.querySelector('svg');
            return (0, _ExtractSvgPaths2['default'])(svg);
        }
    }, {
        key: 'animate',
        value: function animate() {
            var _this = this;

            this.raf = requestAnimationFrame(function (timePassed) {
                if (!_this.startTime) {
                    _this.startTime = timePassed;
                }
                var progress = Math.min((timePassed - _this.startTime) / _this.props.duration, 1);
                var current = (0, _morph.getProgress)(_this.from, _this.to, progress);
                _this.setState({ current: current });
                if (progress >= 1) {
                    return false;
                }
                _this.animate();
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var width = this.props.width;
            var height = this.props.height;
            var viewBox = [0, 0, width, height].join(' ');
            if (this.progress === 100) {
                return _react2['default'].cloneElement(this.props.children, { width: width, height: height });
            }
            return _react2['default'].createElement(
                'svg',
                { viewBox: viewBox, preserveAspectRatio: 'xMidYMid meet', fit: true, width: width, height: height },
                this.state.current.map(function (item, index) {
                    return _react2['default'].createElement('path', _extends({ d: item.path, key: index }, item.attrs, { style: item.style, transform: item.transStr }));
                })
            );
        }
    }]);

    return SvgMorph;
})(_react2['default'].Component);

exports['default'] = SvgMorph;

SvgMorph.propTypes = {
    rotation: _react2['default'].PropTypes.oneOf(['clockwise', 'counterclock', 'none']),
    width: _react2['default'].PropTypes.number,
    height: _react2['default'].PropTypes.number,
    duration: _react2['default'].PropTypes.number,
    children: _react2['default'].PropTypes.element
};

SvgMorph.defaultProps = {
    width: 40,
    height: 40,
    duration: 350,
    rotation: 'clockwise'
};
module.exports = exports['default'];